accounts/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path

from . import views

app_name = 'accounts'

urlpatterns = [
    path('login/', views.SubLoginView.as_view(template_name='accounts/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(
        next_page='accounts:login'), name='logout'),
    path('signup/', views.SignupCreateView.as_view(), name='signup'),
    path('profile/', views.profile_view, name='profile'),
]

neogram/urls.py
from django.conf import settings
from django.contrib import admin
from django.conf.urls.static import static
from django.urls import path, include

urlpatterns = [
    path('accounts/', include('accounts.urls')),
    path('admin/', admin.site.urls),
    path('', include('posts.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

posts/urls.py
from django.urls import path
from . import views 


app_name = 'posts'

urlpatterns = [
    path('', views.index_view, name='index'),
    path('<str:username>/', views.UserProfileView.as_view(), name='profile'),
]

accounts/models.py
from django.contrib.auth.models import User
from django.db import models

# Create your models here.
class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, unique=True)
    biography = models.CharField(max_length=200, blank=True)
    gender = models.CharField(max_length=20, blank=True)
    picture = models.ImageField(upload_to='users/profile/', blank=True)
    website = models.URLField(max_length=100, blank=True)

posts/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Post(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)

    description = models.CharField(max_length=255)
    picture = models.ImageField(upload_to='posts/pics/')

    created = models.DateTimeField(auto_now_add=True)
    Modified = models.DateTimeField(auto_now=True)

accounts/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

from .models import Profile

class LoginForm(forms.Form):
    username = forms.CharField(max_length=150, required=True)
    password = forms.PasswordInput()

class SignupForm(UserCreationForm):
    email = forms.EmailField(label='email')
    first_name = forms.CharField(label='first_name')

    class Meta:
        model = User
        fields = ('email', 'first_name', 'username', 'password1', 'password2')

    def save(self, commit=True):
        user = super().save(commit=False)
        user.set_password(self.cleaned_data["password1"])
        if commit:
            user.save()
            Profile.objects.create(user=user)

        return user

accounts/views.py
from django.contrib.auth import views, forms
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import CreateView

from .forms import SignupForm

# Create your views here.
class SubLoginView(views.LoginView):
    form = forms.AuthenticationForm


def profile_view(request):
    return render(request, 'accounts/profile.html', {'user': request.user})


class SignupCreateView(CreateView):
    form_class = SignupForm
    success_url = reverse_lazy('accounts:login')
    template_name = 'accounts/signup.html'

posts/views.py
from django.shortcuts import render, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import User
from django.views.generic import DetailView

from .models import Post

# Create your views here.
@login_required
def index_view(request):
    posts = Post.objects.all()
    return render(request, 'posts/index.html', {
        'posts': posts,
        'me': request.user,
        })

class UserProfileView(LoginRequiredMixin, DetailView):
    template_name = 'posts/user_profile.html'
    model = User
    slug_url_kwarg = 'username'
    slug_field = 'username'

templates/accounts/login.html
{% extends '../index.html' %}
{% load static %}

{% block head_content %}
  <title>Login • Neogram</title>
{% endblock head_content %}

{% block body %}
  <div class="container vh-100">
    <div class="row d-flex vh-100 align-items-center justify-content-center">
      <div class="col-4">
        <div class="border pt-4 pb-4 pr-4 pl-4">
          <div class="d-flex justify-content-center mb-4">
            <div class="w-50">
              <img class="img-fluid" src="{% static 'neogram_logo.png' %}" alt="neogram_logo" >
            </div>
          </div>
          {% if form.errors %}<div class="alert alert-danger">Invalid Password or Username</div>{% endif %}
          <form action="{% url 'accounts:login' %}" method="post">
              {% csrf_token %}
              <div class="form-group">
                <input class="form-control" type="text" name="username" id="username-login" placeholder="Username">
              </div>
              <div class="form-group">
                <input class="form-control" type="password" name="password" id="pass-login" placeholder="Password">
              </div>
              <input class="btn btn-primary btn-block" type="submit" value="Log In">
              <input type="hidden" name="next" value="{{ next }}">
          </form>
        </div>
        <div class="border w-100 mt-3 d-flex justify-content-center">
          <div class="mt-3 mb-3">
            <span>Don't have an account?</span>
            <a href="{% url 'accounts:signup' %}" class="text-decoration-none font-weight-bold">Sign up</a>
          </div>
        </div>
      </div>
    </div>
  </div>
{% endblock body %}

templates/accounts/profile.html
<h1>User Profile</h1>
<h2>{{ user.first_name }}</h2>

templates/accounts/signup.html
{% extends '../index.html' %}
{% load static %}

{% block head_content %}
  <title>Sign up • Neogram</title>
{% endblock head_content %}

{% block body %}
  <div class="container vh-100">

    <div class="row d-flex vh-100 align-items-center justify-content-center">
      <div class="col-4">
        <div class="border pt-4 pb-4 pr-4 pl-4">
    
          <div class="row justify-content-center">
            <div class="col-6">
              <img class="img-fluid" src="{% static 'neogram_logo.png' %}" alt="neogram_logo" >
            </div>
          </div>

          <div class="row justify-content-center pt-3 pb-3">
            <div class="col-10">
              <h5 class="text-secondary text-center font-weight-bold">Sign up to see photos from your friends</h5>
            </div>
          </div>
          <form action="{% url 'accounts:signup' %}" method="post">
              {% csrf_token %}

              {% if form.errors %}
                <div class="invalid-feedback">{{ form.errors }}</div>
              {% endif %}

              <div class="form-group">
                <input class="form-control {% if form.email.errors %}is-invalid{% endif %}" type="email" name="email" id="email-login" placeholder="Email">
                {% if form.email.errors %}{% for error in form.email.errors %}<div class="invalid-feedback">{{ error }}</div>{% endfor %}{% endif %}
              </div>

              <div class="form-group">
                <input class="form-control {% if form.first_name.errors %}is-invalid{% endif %}" type="text" name="first_name" id="first-name" placeholder="Full name">
                {% if form.first_name.errors %}{% for error in form.first_name.errors %}<div class="invalid-feedback">{{ error }}</div>{% endfor %}{% endif %}
              </div>

              <div class="form-group">
                <input class="form-control {% if form.username.errors %}is-invalid{% endif %}" type="text" name="username" id="username" placeholder="Username">
                {% if form.username.errors %}{% for error in form.username.errors %}<div class="invalid-feedback">{{ error }}</div>{% endfor %}{% endif %}
              </div>

              <div class="form-group">
                <input class="form-control {% if form.password1.errors %}is-invalid{% endif %}" type="password" name="password1" id="password1" placeholder="Password">
                {% if form.password1.errors %}{% for error in form.password1.errors %}<div class="invalid-feedback">{{ error }}</div>{% endfor %}{% endif %}
              </div>

              <div class="form-group">
                <input class="form-control {% if form.password2.errors %}is-invalid{% endif %}" type="password" name="password2" id="password2" placeholder="Password confirmation">
                {% if form.password2.errors %}{% for error in form.password2.errors %}<div class="invalid-feedback">{{ error }}</div>{% endfor %}{% endif %}
              </div>

              <input class="btn btn-primary btn-block" type="submit" value="Sign up">
          </form>
        </div>

        <div class="border w-100 mt-3 d-flex justify-content-center">
          <div class="mt-3 mb-3">
            <span>Have an account?</span>
            <a href="{% url 'accounts:login' %}" class="text-decoration-none font-weight-bold">Log in</a>
          </div>
        </div>

      </div>
    </div>
  </div>
{% endblock body %}

templates/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% load static %}
    <link rel="shortcut icon" href="{% static 'favicon.ico' %}" type="image/x-icon">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.1/css/bootstrap.min.css" integrity="sha384-VCmXjywReHh4PwowAiWNagnWcLhlEJLA5buUprzK8rxFgeH0kww/aWY76TfkUoSX" crossorigin="anonymous">
    <!--Font awesome icons-->
    <script src="https://use.fontawesome.com/2b8d08aeee.js"></script>
    <!-- JS, Popper.js, and jQuery -->
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.1/js/bootstrap.min.js" integrity="sha384-XEerZL0cuoUbHE4nZReLT7nx9gQrQreJekYhJD9WNWhH8nEW+0c5qq7aIo2Wl30J" crossorigin="anonymous"></script>
    {% block head_content %}
    {% endblock head_content %}
</head>
<body>
  {% block body %}
  {% endblock body %}
</body>
</html>

templates/posts/index.html
{% extends '../index.html' %}

{% block head_content %}
<title>Neogram | Feed</title>
{% endblock head_content %}
{% block body %}
  {% include './navbar.html' %}
  <div class="container mt-5 pt-5">
    <div class="row justify-content-center">
      <div class="col-7 pr-5">
        {% for post in posts %}
          <div class="w-100 border rounded">
            <div class="media align-items-center">
              <a href="{% url 'posts:profile' post.user.username %}">
                <img
                  class="rounded-circle mr-3 ml-3 mt-3 mb-3"
                  src="media/{{ post.user.profile.picture }}"
                  alt="profile_pic" width="40px" height="40px"
                >
              </a>
              <div class="media-body">
                <div class="">
                  <a href="{% url 'posts:profile' post.user.username %}" class="font-weight-bold text-decoration-none text-dark">{{ post.user.username }}</a>
                </div>
              </div>
            </div>
            <img class="img-fluid" src="media/{{ post.picture }}" alt="post">
          </div>
          <br><br>
        {% endfor %}
      </div>
      <div class="col-3 pl-0">
        <div class="media align-items-center">
          <a href="#">
            <img
              class="rounded-circle mr-3 ml-3 mt-3 mb-3"
              src="media/{{ me.profile.picture }}"
              alt="profile_pic" width="60px" height="60px"
            >
          </a>
          <div class="media-body">
            <div class="">
              <a href="#" class="font-weight-bold text-decoration-none text-dark">{{ me.username }}</a>
              <div class="text-secondary">{{ me.first_name }}</div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
{% endblock body %}

templates/posts/navbar.html
{% load static %}
<nav class="navbar fixed-top navbar-expand-lg navbar-light bg-white border">
    <div class="container">
      <div class="row justify-content-center">
        <div class="col-10">
          <div class="container-fluid">
            <div class="row">
              <div class="col-6 pl-0">
                <a href="/"><img src="{% static 'neogram_logo.png' %}" alt="neogram_logo" height="35px"></a>
              </div>
              <div class="col-6 pr-0">
                <div class="float-right">
                  <span><i class="fa fa-heart"></i></span>
                  <a href="{% url 'accounts:logout' %}" class="btn btn-outline-dark">Log out</a>
                </div>
              </div>
            </div>
          </div>
        </div>  
      </div>
    </div>
</nav>

templates/posts/user_profile.html
{% extends '../index.html' %}

{% block head_content %}
  <title>{{ user.first_name }}</title>
{% endblock head_content %}

{% block body %}
  {% include './navbar.html' %}
  <div class="container mt-5 pt-4">
    <div class="row justify-content-center">
      <div class="col-10 pr-5">
        <div class="w-100">
          <div class="media align-items-center">
              <a href="/media/{{ user.profile.picture }}">
                <img
                  class="rounded-circle mr-3 ml-3 mt-3 mb-3"
                  src="/media/{{ user.profile.picture }}"
                  alt="profile_pic" width="150px" height="150px"
                >
              </a>
            <div class="media-body">
              <div class="">{{ user.username}}</div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <br><br>
  </div>
{% endblock body %}